# -*- coding: utf-8 -*-
##############################################################################
#
#    Asterisk 360 module for OpenERP
#    Copyright (C) 2012 Les Green <l.green@valuedecision.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
{
    'name': 'Asterisk 360',
    'version': '2.0',
    'category': 'Customer Relationship Management',
    'complexity': "expert",
    'description': """
This module adds the ability to recognise and pop-up the history of customers and log incoming calls via Asterisk.
==================================================================================================================

Detailed documentation can be found at http://www.valuedecision.com/asterisk360

The module is based on and a significant extension of the asterisk_click2dial module of Akkretion.
This module has been developed in co-operation with Cmass Ltd. http://www.cmass-ni.com 

The module has the following abilities:

    - Initiates outgoing calls from scheduled phone calls
    - Creates phone logs for outgoing and incoming calls
    - Auto pop-up of partner history if phone number is recognised for incoming calls
    - Population of phone log with partner and contact as well as call duration
    
... and much more.

Requirements and Installation
-----------------------------
This module is complex; proficient knowledge of Asterisk and OpenERP is necessary.
Detailed instructions can be found at http://www.valuedecision.com/asterisk360 

    """,
    'author': 'ValueDecision Ltd',
    'website': 'http://www.valuedecision.com',
    'depends': ['base','crm','asterisk_click2dial'],
    'data': [],
    'update_xml': ['asterisk360_view.xml',
                   'crm_phonecall_view.xml',
                   'security/asterisk360_user_security.xml',
                   'security/ir.model.access.csv'],
    'test': ['test/asterisk360_partnertest.yml'],
    'installable': True,
    'application': True,
    'auto_install': False,
    'js': ['static/src/js/autobahn.min.js',
           'static/src/js/asterisk360.js'],
    'css': ['static/src/css/asterisk360.css'],
    'qweb' : ["static/src/xml/*.xml"],
    'images': ['images/asterisk_inbound.jpg',
               'images/asterisk_outbound.jpg', 
               'images/asterisk_scheduled.jpg'],
}
