/*---------------------------------------------------------
 * Asterisk360
 *--------------------------------------------------------*/
openerp.asterisk360 = function(instance) {
	var QWeb = instance.web.qweb, _t = instance.web._t, abSession = null;
	
instance.asterisk360.AsteriskWidget = instance.web.Widget.extend({
  
	template: 'systray.asterisk360',
	base_src: '/asterisk360/static/src/',
   
    init: function() {
        this._super.apply(this, arguments);
    },

    onEvent: function(topicUri, event) {
        console.debug(event)

        var action_manager = instance.webclient.action_manager;
        
        var form = new instance.web.form.FormOpenPopup(action_manager);

        if (event.partner_id) {
            form.show_element('res.partner',event.partner_id,{'no_dial_button':true}, 
            		{'title':_.str.sprintf(_t("Incoming Call From %(contact_name)s (%(partner_name)s)"), 
            				{ contact_name: event.address_name ? event.address_name : event.contact_name ? event.contact_name : _t('Unknown Caller'),  
            				  partner_name: event.partner_name}),
            'readonly':false});
            
            form.view_form.has_been_loaded.pipe(function (){
            	var elem = form.$element.find('a[href|="#notebook"]:contains("' + _t('History') +'")');
            	form.$element.find(elem[0]).click();
            });
        } else {
            form.show_element('crm.phonecall',event.openerp_call_id,{'no_dial_button':true}, {'title':_t('Incoming Call From Unknown Caller'),
                'readonly':false, 'no_dial_button':true});
        }
    },
    
    start: function() {
        this._super();
    	var self = this;
        
        new instance.web.DataSet(this, "res.users").read_ids([this.session.uid],
        		['name','screen_pop','internal_number','asterisk_server_id']).then(function(result) {
        	var user = result[0];
        	var sess = instance.webclient.session;
        	sess.screen_pop = user.screen_pop;
        	sess.user_phone = user.internal_number;
        	if (sess.screen_pop==true) {
        		new instance.web.DataSetStatic(this, "asterisk.server").read_ids([user.asterisk_server_id[0]],
        				['name','ws_address']).then(function(result){
        					sess.ws_address=result[0].ws_address;
        					self.connect();
        		});
        	} else {
        		self.set_title_img(_t("Screen Pop Off"));
        	}
        });
        
        this.$element.find('a').click(function(e) {
            e.preventDefault();
            var $help = $(QWeb.render("valuedecision.about", {}));
            $help.dialog({autoOpen: true, modal: true, width: 960, title: "About ValueDecision Ltd."});
            return false;
        });
    },
    
    set_title_img: function(title, src){
		var elem = instance.webclient.$element.find("div.asterisk360"); 
		elem.attr("title",title);
		if (src) {
    		elem.find('img').attr("src",this.base_src + "img/" +src);
		}
    },
    
    connect: function() {
      	var sess = instance.webclient.session;
      	var self = this;
      	if (!self.abSession) {
      		self.wsconnecting = true;
      	    abSession = new ab.Session(sess.ws_address,function(){
      			console.debug("connected");
      			abSession.prefix("callsto","asterisk360/callsto#");
      			var channel = "callsto:" + sess.user_phone;
      			abSession.subscribe(channel, self.onEvent);
      			console.debug("subscribed:" + channel);
      			self.set_title_img(sess.ws_address,"call_green.png");
      			self.wsconnecting = false;
            }, function(){
      			self.set_title_img(_t("Not Connected"),"call_red.png");
      			self.abSession = null;
      			var connecting = self.wsconnecting;
      			self.wsconnecting = false;
      			if (!connecting){
      				//var reconnect = confirm(_t("Screen Pop Connection Broken\n Do you wish to try to Reconnect?"));
      				var reconnect = true; //Automatically reconnect
          			if (reconnect){
          				self.connect();
          			}
          		}
      		})
      	}
    }
});

instance.web.Header.include({
	
	do_update: function() {
		var self = this;
		this._super();
		this.update_promise.then(function() {
				self.asterisk360 = new instance.asterisk360.AsteriskWidget(self);
				self.asterisk360.prependTo(self.$element.find('div.header_corner'));
		});
	}
});

};
